var GooglePlusTab = {
/* Simple debugging to the error console */
enableDebug: false,
debug: function (aMessage) {
	if(GooglePlusTab.enableDebug) {
		let consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
		consoleService.logStringMessage("google-plus-tab: " + aMessage);
	}
},


onLoad: function() {
    // initialisation code:
 	// If the completeInstall flag is true, the button has already been installed
	try{
		GooglePlusTab.debug("start");
		let installButton = true;
		let prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		prefBranch.deleteBranch("extensions.google-plus-tab@michael.graflinstallComplete");
		
		prefBranch = prefBranch.getBranch("extensions.google-plus-tab@michael.grafl.");
		if (prefBranch && prefBranch.getPrefType("installComplete") == prefBranch.PREF_BOOL){
			installButton = !prefBranch.getBoolPref("installComplete");
		}
		GooglePlusTab.debug("installComplete is " + !installButton);
	
		if (installButton) {
			GooglePlusTab.debug("installing button");
			// Find the navigation bar and append the CloseAllTabs button
			prefBranch.setBoolPref("installComplete", true);
			let mainNavBar = document.getElementById("mail-bar3");
			
			if(!mainNavBar || !mainNavBar.currentSet) {
				GooglePlusTab.debug("Error installing button: toolbar not present.");
				return;
			}
			
			let curSet = mainNavBar.currentSet;
			if (curSet.indexOf("google-plus-tab-toolbar-button") == -1) {
				let insertPos = curSet.indexOf("button-address");
				if (insertPos > -1) {
					// Insert the button after the address book button:
					insertPos += 14; // "button-address".length
					curSet = curSet.substring(0,insertPos) + ",google-plus-tab-toolbar-button"+ curSet.substring(insertPos);
				} else {
					curSet = curSet + ",google-plus-tab-toolbar-button";
				}
				
				GooglePlusTab.debug("curSet: " + curSet);
				
				// Tutorial says that we have to perform the following steps
				mainNavBar.setAttribute("currentset", curSet);
				mainNavBar.currentSet = curSet;
				document.persist("mail-bar3", "currentset");
				try {
					BrowserToolboxCustomizeDone(true);
				} catch (e) { }
				GooglePlusTab.debug("button successfully installed");
			} 
		}
	} catch(e) { alert("Error installing google-plus-tab: " + e); }
},

onToolbarButtonCommand: function(e) {
	// Open a new tab with Google Calendar
    let mailPane = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("mail:3pane");
    mailPane.document.getElementById("tabmail").openTab("contentTab", {contentPage: "http://plus.google.com", type: "googleplus"});
}
};

window.addEventListener("load", GooglePlusTab.onLoad, false);
